// Selector.h : Declaration of the CSelector

#ifndef __SELECTOR_H_
#define __SELECTOR_H_

#include "resource.h"       // main symbols
#include "ifunctoidimpl.h"  // IFunctoidImpl provided by BizTalk Unleashed

/////////////////////////////////////////////////////////////////////////////
// CSelector
class ATL_NO_VTABLE CSelector : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CSelector, &CLSID_Selector>,
	public IDispatchImpl<ISelector, &IID_ISelector, &LIBID_SELECTORFUNCTOIDLib>,
    public IFunctoidDispatchImpl<CSelector, &LIBID_SELECTORFUNCTOIDLib>
{
public:
	CSelector()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SELECTOR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_CATEGORY_MAP(CSelector)
    IMPLEMENTED_CATEGORY(CATID_MapEditFunctoids)
END_CATEGORY_MAP()

BEGIN_COM_MAP(CSelector)
	COM_INTERFACE_ENTRY(IFunctoid)
	COM_INTERFACE_ENTRY2(IDispatch, IFunctoid)
	COM_INTERFACE_ENTRY(ISelector)
END_COM_MAP()

// IFunctoid implementation
//      Most of the implementation is handled in base class IFunctoidDispatchImpl.
//      This base class uses the meta data defined using BEGIN_FUNCTOID_MAP/END_FUNCTOID_MAP.
//      The implementation for IFunctoid::GetScriptBuffer() will make callbacks to
//      functions defined here.  These function names are in the functoid map in the .cpp file.
public:
    DECLARE_FUNCTOID_MAP()
    BSTR GetSelectorImpl ( long nParameters );

// ISelector
public:
};

#endif //__SELECTOR_H_
