<html>
<head>
<title>BizTalk Unleashed--Batch Submission for Custom Parser</title>

<script language="javascript">

var g_divs, g_toolbars;
function initInstance ()
{
    g_divs     = new Array(divitem,     divbatch,     divhelp);
    g_toolbars = new Array(itemtoolbar, batchtoolbar, null);
    showDiv(divitem);

    clearBatch();
}

function showDiv ( divtoshow )
{
    var toolbartoshow = null; 
    for ( var i = 0;  i < g_divs.length;  i ++ )
    {
        var d = g_divs[i], tb = g_toolbars[i];
        d.style.display = "none";
        if (tb != null) tb.style.display = "none";
        if (d == divtoshow) toolbartoshow = tb;
    }
    if (divtoshow     != null) divtoshow.style.display = "block";
    if (toolbartoshow != null) toolbartoshow.style.display = "block";
}

function batchItem()
{
    appendBatchItems(formatFormPostData(itemform));
    alert("Batched.\n\nClick the 'View Batch' button on the toolbar to review the batch.");
}

function appendBatchItems ( items )
{
    document.all.batch.innerText += "\r\n" + items;
}

function formatFormPostData ( form )
{
    var s = "";
    for ( var e = 0;  e < form.elements.length;  e ++ )
    {
        var n = form.elements[e].name, v = form.elements[e].value;
        if (n.length > 0)
            s += ((s.length == 0) ? "" : "&") + n + "=" + encodeURIComponent(v);
    }
    return s;
}

function insertRandomItem()
{
    var form = itemform;
    for ( var e = 0;  e < form.elements.length;  e ++ )
    {
        var elem = form.elements[e];
        if (elem.tagName.toUpperCase() == "SELECT")
        {
            var r = ran(0, elem.children.length-1); // pick random number in range 0..N-1, N=number of combobox values
            elem.children[r].selected = "true";
        }
    }
}

function ran ( n1, n2 ) // return random integer in the range n1 to n2; n1 and n2 must be integers
{
    return n1 + Math.floor(Math.random() * (n2 - n1 + 1));
        // note:  Math.random() returns value in open interval [0,1).  Specifically, may be 0 but will never be 1.
}

function getPostBackUrl ()
{
    return "http://<%= request.servervariables("SERVER_NAME") + left(request.servervariables("PATH_INFO"), instrrev(request.servervariables("PATH_INFO"),"/")-1)%>";
}

function submitBatch()
{
    var http = null;
    var url = getPostBackUrl() + "/BizTalkHTTPReceive.dll";
    try
    {
        http = new ActiveXObject("MSXML2.XMLHTTP.3.0");
        http.open("POST", url, false);
        alert("Posting to " + url + ":\n\n" + document.all.batch.innerText.toString());
        http.send(document.all.batch.innerText.toString());
        alert("HTTP Post returned:\n" + http.responseText);
        clearBatch();
    }
    catch ( x )
    {
        var msg = "Can not do HTTP post to '" + url + "'.\n\n";
        if (http == null)
            msg += "Need MSXML3 installed.\n\n";
        else
            msg += "     http.status[" + http.status + " " + http.statusText + "]\n";
        for ( var f in x )
            msg += "     exception." + f + "[" + x[f] + "]\n";
        alert(msg);
    }
}

function clearBatch()
{
    document.all.batch.innerText = "schema=biztalk-unleashed-custom-parser-ch18";
}

g_sampleBatchData = new Array(2);
g_sampleBatchData[0] = 
    "broker=Delta%20Partners&stock=WXYZ&quantity=1000&min-price=25.00\r\n" +
    "broker=Beta%20Brokerage&stock=JKL&quantity=1500&min-price=35.00\r\n" +
    "broker=Beta%20Brokerage&stock=WXYZ&quantity=2500&min-price=100.00\r\n" +
    "broker=Alpha%20Financials&stock=DEF&quantity=2500&min-price=20.00\r\n" +
    "broker=Delta%20Partners&stock=STUV&quantity=50&min-price=35.00\r\n";
g_sampleBatchData[1] =
    "broker=Bet%20Brokerage&stock=STUV&quantity=50&min-price=45.00\r\n" +
    "broker=Delta%20Partners&stock=DEF&quantity=500&min-price=25.00\r\n" +
    "broker=Alpha%20Financials&stock=PQR&quantity=100&min-price=45.00\r\n" +
    "broker=Alpha%20Financials&stock=PQR&quantity=100&min-price=45.00\r\n" +
    "broker=Alpha%20Financials&stock=JKL&quantity=250&min-price=35.00\r\n" +
    "broker=Beta%20Brokerage&stock=DEF&quantity=1500&min-price=5.00\r\n" +
    "broker=Beta%20Brokerage&stock=GHI&quantity=1500&min-price=45.00\r\n" +
    "broker=Delta%20Partners&stock=PQR&quantity=1000&min-price=20.00\r\n" +
    "broker=Alpha%20Financials&stock=PQR&quantity=1000&min-price=35.00\r\n" +
    "broker=Delta%20Partners&stock=PQR&quantity=2500&min-price=45.00\r\n" +
    "broker=Gamma%20Trade%20Services&stock=MNO&quantity=1500&min-price=25.00\r\n" +
    "broker=Alpha%20Financials&stock=ABC&quantity=250&min-price=100.00\r\n" +
    "broker=Alpha%20Financials&stock=STUV&quantity=2500&min-price=35.00\r\n" +
    "broker=Gamma%20Trade%20Services&stock=WXYZ&quantity=250&min-price=45.00\r\n" +
    "broker=Gamma%20Trade%20Services&stock=MNO&quantity=2500&min-price=5.00\r\n" +
    "broker=Gamma%20Trade%20Services&stock=GHI&quantity=100&min-price=5.00\r\n" +
    "broker=Beta%20Brokerage&stock=GHI&quantity=1000&min-price=5.00\r\n" +
    "broker=Beta%20Brokerage&stock=PQR&quantity=250&min-price=45.00\r\n" +
    "broker=Beta%20Brokerage&stock=JKL&quantity=10&min-price=10.00\r\n" +
    "broker=Gamma%20Trade%20Services&stock=ABC&quantity=250&min-price=100.00\r\n" +
    "broker=Delta%20Partners&stock=JKL&quantity=50&min-price=25.00\r\n" +
    "broker=Beta%20Brokerage&stock=MNO&quantity=50&min-price=25.00\r\n" +
    "broker=Alpha%20Financials&stock=GHI&quantity=500&min-price=35.00\r\n" +
    "broker=Beta%20Brokerage&stock=PQR&quantity=1000&min-price=20.00\r\n";


function addSampleBatch()
{
    var i = (samplebatch.value == "1") ? 0 : 1;
    appendBatchItems(g_sampleBatchData[i]);
}

</script>

</head>


<body bgcolor="black" onload="initInstance()">

<!-- title -->
<div style="background-color:lightsteelblue; border-style:groove; width:100%; margin-bottom:4px;">
<h1 style="margin:0"><center>Batch Submission Test Driver</center></h1>
<h3 style="margin:0" align="right">for BizTalk Custom Parser&nbsp;&nbsp;&nbsp;</h3>
<h3 style="margin:0" align="right"><u>BizTalk Unleashed</u> Book Sample&nbsp;&nbsp;&nbsp;</h3>
</div>

<!-- toolbar -->
<div style="background-color:lightslategray; border-style:groove; width:100%; margin-bottom:4px;">
    <table width="100%" cellspacing="0" cellpadding="0" border="0">
        <tr>
            <td align="left" style="color:black">
               <table>
                  <tr>
                     <td>
                        <input style="font:bold 10pt; background-color:lightsteelblue; height:16pt;" type="button" value="View Item" onclick="showDiv(divitem)"/>
                     </td>
                     <td>
                        <input style="font:bold 10pt; background-color:lightsteelblue; height:16pt;" type="button" value="View Batch" onclick="showDiv(divbatch)"/>
                     </td>
                     <td>
                        <input style="font:bold 10pt; background-color:lightsteelblue; height:16pt;" type="button" value="Help" onclick="showDiv(divhelp)"/>
                     </td>
                     <td width="8px"></td>
                     <td width="2px" style="background-color:black"></td>
                     <td width="8px"></td>
                     <td id="itemtoolbar" style="display:none">
                        <table>
                            <tr>
                                <td><input style="font:8pt; background-color:lightsteelblue; height:14pt;" type="button" value="Batch this Item" onclick="document.all.batchitembutton.click()"/></td>
                                <td><input style="font:8pt; background-color:lightsteelblue; height:14pt;" type="button" value="New Random Item" onclick="insertRandomItem()"/></td>
                            </tr>
                        </table>
                     </td>
                     <td id="batchtoolbar" style="display:none">
                        <table>
                            <tr>
                                <td><input style="font:8pt; background-color:lightsteelblue; height:14pt;" type="button" value="Clear Batch" onclick="clearBatch()"/></td>
                                <td><input style="font:8pt; background-color:lightsteelblue; height:14pt;" type="button" value="Submit Batch" onclick="submitBatch()"/></td>
                                <td width="4px"></td>
                                <td width="1px" style="background-color:black"></td>
                                <td width="4px"></td>
                                <td><input style="font:8pt; background-color:lightsteelblue; height:14pt;" type="button" value="Add Sample:" onclick="addSampleBatch()"/>
                                    <select style="font:8pt" name="samplebatch" size="1">
                                        <option value="1">Small Sample</option>
                                        <option value="2">Large Sample</option>
                                    </select>
                                </td>
                            </tr>
                        </table>
                     </td>
                  </tr>
               </table>
            </td>
        </tr>
    </table>
</div>

<!-- help -->
<div id="divhelp" style="display:none; padding:16px; background-color:lavender; border-style:groove; width:100%">
    <p><b>This test driver</b> is for the custom BizTalk parser in Chapter 18.  This application submits 
       non-XML data into an HTTP Receive Function.  That receive function places the data into a channel
       at which time the customer parser converts it to XML.
    </p>
    <p><b>To use this application</b>, construct a batch of items to submit.
    </p>
    <p><b>How to batch an item:</b> Use the <i>View Item</i> button on the toolbar to get to the Item page.
       More buttons will appear on the toolbar. Fill in the form and press the <i>Batch this Item</i> button on the toolbar.
    </p>
    <p><b>How to quickly batch many items:</b> On the Item page, fill the form with random
       data using the <i>New Random Item</i> button on the toolbar.  Then press the <i>Batch this Item</i> button.
       Repeat this process to quickly batch many items.
    </p>
    <p><b>How to review the batched items:</b> Use the <i>View Batch</i> button on the toolbar to get to the Batch page.
       More buttons will appear on the toolbar for managing the batch.
    </p>
    <p><b>How to submit the batched items:</b> On the Batch page, press the <i>Submit Batch</i> button on the toolbar.
    </p>
    <p><b>How to clear the batch without submitting:</b> On the Batch page, press the <i>Clear Batch</i> button on the toolbar.
    </p>
    <p><b>How to shortcut the batching process:</b> On the Batch page, select a sample batch from the combobox on
       the toolbar.  Press the <i>Add Sample</i> button.  Sample data will append to the current batch.
    </p>
</div>

<!-- item form -->
<div id="divitem" style="display:none; padding:16px; background-color:lavender; border-style:groove; width:100%;">
    <table>
        <tr>
            <td valign="top"><h2>Item:</h2></td>
            <td width="16px"></td>
            <td>
                <form name="itemform" onsubmit="batchItem(); return false;">
                    <table>
                        <tr>
                            <td>Broker:&nbsp;</td>
                            <td><select name="broker" size="1">
                                    <option value="Alpha Financials">Alpha Financials</option>
                                    <option value="Beta Brokerage">Beta Brokerage</option>
                                    <option value="Gamma Trade Services">Gamma Trade Services</option>
                                    <option value="Delta Partners">Delta Partners</option>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td>Stock Symbol:&nbsp;</td>
                            <td><select name="stock" size="1">
                                    <option value="ABC">ABC</option>
                                    <option value="DEF">DEF</option>
                                    <option value="GHI">GHI</option>
                                    <option value="JKL">JKL</option>
                                    <option value="MNO">MNO</option>
                                    <option value="PQR">PQR</option>
                                    <option value="STUV">STUV</option>
                                    <option value="WXYZ">WXYZ</option>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td>Quantity:&nbsp;</td>
                            <td><select name="quantity" size="1">
                                    <option value="10">10</option>
                                    <option value="50">50</option>
                                    <option value="100">100</option>
                                    <option value="250">250</option>
                                    <option value="500">500</option>
                                    <option value="1000">1000</option>
                                    <option value="1500">1500</option>
                                    <option value="2500">2500</option>
                                </select>
                            </td>
                        </tr>
                        <tr>
                            <td>Min Price:&nbsp;</td>
                            <td><select name="min-price" size="1">
                                    <option value="5.00">5.00</option>
                                    <option value="10.00">10.00</option>
                                    <option value="20.00">20.00</option>
                                    <option value="25.00">25.00</option>
                                    <option value="35.00">35.00</option>
                                    <option value="45.00">45.00</option>
                                    <option value="60.00">60.00</option>
                                    <option value="100.00">100.00</option>
                                </select>
                            </td>
                        </tr>
                        <tr style="display:none">
                            <td colspan="2"><input type="submit" id="batchitembutton" value="Batch it"></td>
                        </tr>
                    </table>
                </form>
            </td>
        </tr>
    </table>
</div>

<!-- batch -->
<div id="divbatch" style="display:none; padding:16px; background-color:lavender; border-style:groove; width:100%; height:75%">
    <table>
        <tr>
            <td>
                <h2>Batch:</h2>
                <table>
                    <tr>
                        <td valign="top">
                            <textarea name="batch" cols="75" rows="16" style="font:8pt"></textarea>
                        </td>
                        <td>
                            <p>Each item in the batch is in the HTTP Form Post syntax.  Items are newline-delimited.</p>
                            <p>The entire batch will be submitted using an HTTP Post.  The BizTalk HTTP Receive Function 
                               will accept the post and submit to a BizTalk Channel.  The channel will use a custom
                               parser to handle each line as a distinct form post.</p>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
</div>

</body>

</html>
